# Version options
%define kernel_base_version	2.6.16
%define kernel_extra_version	%nil
# Numeric extra version scheme developed by Alexander Bokovoy:
# 0.0.X -- preX
# 0.X.0 -- rcX
# 1.0.0 -- release
%define kernel_extra_version_numeric 1.0.0
%define krelease alt7

%define base_flavour	xen026
%define flavour		%base_flavour

# Build options
# You can change compiler version by editing this line:
%define kgcc_version	3.4

# Enable/disable SGML docs formatting
#def_enable docs

%add_patch_list kernel-feat-arch-xen

#add_patch_list kernel-fix-security
#add_patch_list kernel-fix-build
#add_patch_list kernel-fix-core
#add_patch_list kernel-fix-acpi
#add_patch_list kernel-fix-fs
#add_patch_list kernel-fix-net
#add_patch_list kernel-fix-drivers-atm
#add_patch_list kernel-fix-drivers-block
#add_patch_list kernel-fix-drivers-char
#add_patch_list kernel-fix-drivers-hwmon
#add_patch_list kernel-fix-drivers-i2c
#add_patch_list kernel-fix-drivers-ide
#add_patch_list kernel-fix-drivers-ieee1394
#add_patch_list kernel-fix-drivers-input
#add_patch_list kernel-fix-drivers-md
#add_patch_list kernel-fix-drivers-media
#add_patch_list kernel-fix-drivers-mtd
#add_patch_list kernel-fix-drivers-net
#add_patch_list kernel-fix-drivers-parport
#add_patch_list kernel-fix-drivers-pci
#add_patch_list kernel-fix-drivers-pcmcia
#add_patch_list kernel-fix-drivers-scsi
#add_patch_list kernel-fix-drivers-serial
#add_patch_list kernel-fix-drivers-sound
#add_patch_list kernel-fix-drivers-usb
#add_patch_list kernel-fix-drivers-video
%add_patch_list kernel-fix-security-altsec
#add_patch_list kernel-fix-core-skbuff

# Features:

#add_patch_list kernel-feat-drivers-drm
#add_patch_list kernel-feat-drivers-video-splash
#add_patch_list kernel-feat-drivers-input
#add_patch_list kernel-feat-drivers-net-sk98lin
#add_patch_list kernel-feat-drivers-pktcdvd
#add_patch_list kernel-feat-fs-squashfs
#add_patch_list kernel-feat-net-ieee80211
#add_patch_list kernel-feat-net-ppp-mppe
#add_patch_list kernel-feat-evms-nodm


#add_patch_list kernel-fix-arch-xen

# imz: Unicode support in VT/console
#add_patch_list kernel-feat-drivers-console-unicode
# Although this patch changes the interface between the kernel and loadkeys,
# I do not put a Conflicts for the old console-tools here,
# because the old loadkeys works fine the new kernel interface.

## Don't edit below this line ##################################

%define kversion	%kernel_base_version%kernel_extra_version
%define modules_dir	/lib/modules/%kversion-%flavour-%krelease
%ifarch x86_64
%define ncarch i386
%else
%define ncarch x86_64
%endif


Name: kernel-image-%flavour
Version: %kversion
Release: %krelease

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: System/Kernel and hardware
#Packager: XEN Maintainers Team <xen@packages.altlinux.org>

%set_kernel_arches i586 x86_64

ExclusiveOS: Linux

BuildRequires: dev86 flex
BuildRequires: libdb4-devel
BuildRequires: gcc%kgcc_version
BuildRequires: kernel-source-%{kernel_base_version} = %{kernel_extra_version_numeric}
BuildRequires: kernel-build-tools >= 0.7, modutils >= 2.4.27-alt1

BuildRequires: %get_patch_list

%if_enabled docs
BuildRequires: xmlto transfig ghostscript
%endif

%if_enabled ccache
BuildRequires: ccache
%endif

%ifdef use_ccache
BuildRequires: ccache
%endif

Requires: bootloader-utils >= 0.3-alt1
Requires: modutils >= 2.4.27-alt1
Requires: mkinitrd >= 1:2.9.2-alt1
Requires: startup >= 0.8.3-alt1

Provides: kernel = %kversion

Prereq: coreutils
Prereq: modutils >= 2.4.27
Prereq: mkinitrd >= 1:2.9.2-alt1
ExclusiveArch:	%ix86

%description
This package contains the Linux kernel that is used to boot and run
your system.

The "xen026" variant of kernel packages is a XenLinux kernel which 
contains hardware device drivers and drivers for Xen's virtual devices.

Xen is an open-source para-virtualizing virtual machine monitor (VMM), 
or 'hypervisor', for the x86 processor architecture. Xen can securely
execute multiple virtual machines on a single physical system with
close-to-native performance.

Most hardware drivers for this kernel are built as modules.  Some of
these drivers are built separately from the kernel; they are available
in separate packages (kernel-modules-*-%flavour).

Patches included:%format_patch_list

%package -n kernel-modules-oss-%flavour
Summary: OSS sound driver modules (obsolete)
Group: System/Kernel and hardware
Provides:  kernel-modules-oss-%kversion-%flavour-%krelease = %version-%release
Conflicts: kernel-modules-oss-%kversion-%flavour-%krelease < %version-%release
Conflicts: kernel-modules-oss-%kversion-%flavour-%krelease > %version-%release
Prereq: coreutils
Prereq: modutils
Prereq: %name = %version-%release
Requires(postun): %name = %version-%release

%description -n kernel-modules-oss-%flavour
This package contains OSS sound driver modules for the Linux kernel
package %name-%version-%release.

These drivers are declared obsolete by the kernel maintainers; ALSA
drivers should be used instead.  However, the older OSS drivers may be
still useful for some hardware, if the corresponding ALSA drivers do
not work well.

Install this package only if you really need it.

%package -n kernel-headers-%flavour
Summary: Header files for the Linux kernel
Group: System/Kernel and hardware
Requires: kernel-headers-common >= 1.1.5
Provides: kernel-headers = %version

%description -n kernel-headers-%flavour
This package makes Linux kernel headers corresponding to the Linux
kernel package %name-%version-%release available for building
userspace programs (if this version of headers is selected by
adjust_kernel_headers).

Note that such usage of kernel headers in userspace is not supported
by the upstream kernel maintainers and often breaks compilation.
Therefore installing and using this package is not recommended.

%package -n kernel-headers-modules-%flavour
Summary: Headers and other files needed for building kernel modules
Group: System/Kernel and hardware
Requires: kernel-headers-%flavour = %version-%release
Requires: gcc%kgcc_version

%description -n kernel-headers-modules-%flavour
This package contains header files, Makefiles and other parts of the
Linux kernel build system which are needed to build kernel modules for
the Linux kernel package %name-%version-%release.

If you need to compile a third-party kernel module for the Linux
kernel package %name-%version-%release, install this package
and specify %_prefix/src/linux-%version-%flavour as the kernel source
directory.

%package -n kernel-doc-%base_flavour
Summary: Linux kernel %kversion-%base_flavour documentation
Group: System/Kernel and hardware

%description -n kernel-doc-%base_flavour
This package contains documentation files for ALT Linux kernel packages:
 * kernel-image-%base_flavour-up-%kversion-%krelease
 * kernel-image-%base_flavour-smp-%kversion-%krelease

The documentation files contained in this package may be different
from the similar files in upstream kernel distributions, because some
patches applied to the corresponding kernel packages may change things
in the kernel and update the documentation to reflect these changes.

%prep
%setup -cT -n kernel-image-%flavour-%kversion-%krelease
%__rm -rf kernel-source-%kernel_base_version
%__tar -jxf %kernel_src/kernel-source-%kernel_base_version.tar.bz2
%setup -D -T -n kernel-image-%flavour-%kversion-%krelease/kernel-source-%kernel_base_version

echo "patches = %_patch_list"

%apply_patches 2.6

# this file should be usable both with make and sh (for broken modules
# which do not use the kernel makefile system)
echo 'export GCC_VERSION=%kgcc_version' > gcc_version.inc

%__subst 's/EXTRAVERSION[[:space:]]*=.*/EXTRAVERSION = %kernel_extra_version-%flavour-%krelease/g' Makefile
%__subst 's/CC.*$(CROSS_COMPILE)gcc/CC         := $(shell echo $${GCC_USE_CCACHE:+ccache}) gcc-%kgcc_version/g' Makefile

# get rid of unwanted files resulting from patch fuzz
find . -name "*.orig" -delete -or -name "*~" -delete

%build
KernelVer=%kversion-%flavour-%krelease

echo "Building Kernel $KernelVer"

%make_build ARCH=%base_arch mrproper

%__cp -vf %{get_kernel_config %_target_cpu} .config

%make_build ARCH=%base_arch oldconfig
%make_build ARCH=%base_arch include/linux/version.h

%make_build ARCH=%base_arch vmlinuz
%make_build ARCH=%base_arch modules

echo "Kernel built $KernelVer"

%if_enabled docs
# psdocs, pdfdocs don't work yet
%make_build ARCH=%base_arch htmldocs
%endif

KernelVer=%kversion-%flavour-%krelease

%__install -Dp -m644 System.map %buildroot/boot/System.map-$KernelVer
%__install -Dp -m644 vmlinuz %buildroot/boot/vmlinuz-$KernelVer
%__install -Dp -m644 .config %buildroot/boot/config-$KernelVer

%__make ARCH=%base_arch modules_install INSTALL_MOD_PATH=%buildroot

%__install -d %buildroot%_prefix/include/linux-%version-%flavour/include

pushd include
%__cp -a . %buildroot%_prefix/include/linux-%version-%flavour/include
popd

# remove asm-* include files for other architectures
pushd %buildroot%prefix/include/linux-%version-%flavour/include
for dir in asm-*; do
	[ "$dir" = "asm-generic" ] && continue
	[ "$dir" = "asm-%base_arch" ] && continue
	[ "$dir" = "asm-%ncarch" ] && continue
	%__rm -rf -- "$dir"
done
popd

%__install -d %buildroot%_prefix/src/linux-%version-%flavour/drivers/scsi
%__install -d %buildroot%_prefix/src/linux-%version-%flavour/drivers/char/drm
%__install -d %buildroot%_prefix/src/linux-%version-%flavour/drivers/md
%__install -d %buildroot%_prefix/src/linux-%version-%flavour/drivers/media/video
%__cp -a drivers/scsi/{{scsi,hosts,scsi_typedefs}.h,scsi_module.c} \
	%buildroot%_prefix/src/linux-%version-%flavour/drivers/scsi/
%__cp -a drivers/char/drm/{drm,drm_os_linux,drmP}.h \
	%buildroot%_prefix/src/linux-%version-%flavour/drivers/char/drm/
%__cp -a drivers/md/dm*.h \
	%buildroot%_prefix/src/linux-%version-%flavour/drivers/md/
%__cp -a drivers/media/video/{bt848,btcx-risc,bttv,bttvp}.h \
	%buildroot%_prefix/src/linux-%version-%flavour/drivers/media/video/

%__install -d %buildroot%_prefix/src/linux-%version-%flavour
pushd %buildroot%_prefix/src/linux-%version-%flavour
%__ln_s -f ../../include/linux-%version-%flavour/include ./include
popd

# Install files required for building external modules (in addition to headers)
KbuildFiles="
	Makefile
	Module.symvers
	arch/%base_arch/Makefile
	arch/%base_arch/Makefile.cpu

	scripts/pnmtologo
	scripts/mod/modpost
	scripts/mkmakefile
	scripts/mkversion
	scripts/mod/mk_elfconfig
	scripts/kconfig/conf
	scripts/mkcompile_h
	scripts/makelst
	scripts/Makefile.modpost
	scripts/Makefile.modinst
	scripts/Makefile.lib
	scripts/Makefile.host
	scripts/Makefile.clean
	scripts/Makefile.build
	scripts/Makefile
	scripts/Kbuild.include
	scripts/kallsyms
	scripts/genksyms/genksyms
	scripts/basic/fixdep
	scripts/extract-ikconfig
	scripts/conmakehash
	scripts/checkversion.pl
	scripts/checkincludes.pl
	scripts/checkconfig.pl
	scripts/bin2c
	scripts/gcc-version.sh

	.config
	.kernelrelease
	gcc_version.inc
"
for f in $KbuildFiles; do
	[ -e "$f" ] || continue
	[ -x "$f" ] && mode=755 || mode=644
	%__install -Dp -m$mode "$f" \
		%buildroot%_prefix/src/linux-%version-%flavour/"$f"
done

%__rm -f %buildroot%modules_dir/{build,source}
%__ln_s %_prefix/src/linux-%version-%flavour %buildroot%modules_dir/build

# install documentation
%if_enabled docs
%__install -d %buildroot%_docdir/kernel-doc-%base_flavour-%version/
%__cp -a Documentation/* %buildroot%_docdir/kernel-doc-%base_flavour-%version/
%__install -d %buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/
for dir in aacraid; do
	%__install -d \
		%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/$dir/
	%__cp -a drivers/scsi/$dir/README* \
		%buildroot%_docdir/kernel-doc-%base_flavour-%version/scsi/$dir/
done
find %buildroot%_docdir/kernel-doc-%base_flavour-%version/DocBook \
	-maxdepth 1 -type f -not -name '*.html' -delete
%endif # if_enabled docs

%post
%post_kernel_image %kversion-%flavour-%krelease

%preun
%preun_kernel_image %kversion-%flavour-%krelease

%post -n kernel-modules-oss-%flavour
%post_kernel_modules %kversion-%flavour-%krelease

%postun -n kernel-modules-oss-%flavour
%postun_kernel_modules %kversion-%flavour-%krelease

%post -n kernel-headers-%flavour
%post_kernel_headers %kversion-%flavour-%krelease

%postun -n kernel-headers-%flavour
%postun_kernel_headers %kversion-%flavour-%krelease

%files
/boot/vmlinuz-%kversion-%flavour-%krelease
/boot/System.map-%kversion-%flavour-%krelease
/boot/config-%kversion-%flavour-%krelease
%modules_dir
%exclude %modules_dir/build

# OSS drivers
%exclude %modules_dir/kernel/sound/oss
%ifarch %ix86
#exclude %modules_dir/kernel/drivers/media/radio/miropcm20.ko
#exclude %modules_dir/kernel/drivers/media/radio/miropcm20-rds.ko
%endif
%exclude %modules_dir/kernel/drivers/usb/class/audio.ko
%exclude %modules_dir/kernel/drivers/usb/class/usb-midi.ko

%files -n kernel-modules-oss-%flavour
%modules_dir/kernel/sound/oss
%ifarch %ix86
#modules_dir/kernel/drivers/media/radio/miropcm20.ko
#modules_dir/kernel/drivers/media/radio/miropcm20-rds.ko
%endif
%modules_dir/kernel/drivers/usb/class/audio.ko
%modules_dir/kernel/drivers/usb/class/usb-midi.ko

%files -n kernel-headers-%flavour
%_prefix/include/linux-%version-%flavour

%files -n kernel-headers-modules-%flavour
%_prefix/src/linux-%version-%flavour
%modules_dir/build

%if_enabled docs
%files -n kernel-doc-%base_flavour
%doc %_docdir/kernel-doc-%base_flavour-%version
%endif

%changelog
* Thu Dec 21 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt7
- 3.0.4

* Mon Nov 06 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt6
- fix build for x86_64

* Wed Oct 18 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt5
- new xen version 3.0.3
- enabled PAE 

* Tue Oct 17 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt4
- fix build for x86_64

* Fri Oct 06 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt3
- change build scheme
- stable release

* Thu Jun 29 2006 Alex Yustasov <yust@altlinux.ru> 2.6.16-alt2
- fixed config for i586: 
    CONFIG_HIGHMEM4G=y, turned off CONFIG_PAE and CONFIG_HIGHMEM64G

* Thu Jun 08 2006 Alex Yustasov <yust@altlinux.ru> 2.6.16-alt1
- xen-2.6.16-3.0.2-3

* Mon Jul 04 2005 Alex Yustasov <yust@altlinux.ru> 2.6.12-alt1
- initial build

